package xbc.formula.engine.exp.util;

import java.math.BigDecimal;
import java.math.RoundingMode;

import xbc.formula.engine.exp.exception.XbcExpExecException;

public class XbcExpNumericUtil {

	public static BigDecimal translate2BigDecimal(Object value, int weishu, RoundingMode roundMode, String expStr) {
		if(value == null) {
			return BigDecimal.ZERO;
		}
		if(value.getClass() == BigDecimal.class) {
			return (BigDecimal)value;
		}
		if(value.getClass() == Integer.class || value.getClass() == int.class) {
			return new BigDecimal((int)value);
		}
		if(value.getClass() == Long.class || value.getClass() == long.class) {
			return new BigDecimal((long)value);
		}
		if(value.getClass() == Double.class || value.getClass() == double.class) {
			BigDecimal bv = new BigDecimal((double)value);
			bv = bv.setScale(weishu, roundMode);
			return bv;
		}
		throw new XbcExpExecException("BigDecimal类型转换，不支持的数据类型: " + value.getClass().getName() + "。公式: " + expStr);
	}
}
