package xbc.formula.calcmgr.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import xbc.formula.calcmgr.service.CalculateManagerService;
import xbc.formula.calcmgr.vo.CalcResultDescVo;
import xbc.formula.calcmgr.vo.CalculateRequestVo;
import xbc.formula.calcmgr.vo.CalculateResponseVo;

@RestController
@RequestMapping("/calculatemanager")
public class CalculateManagerController {
	
	@Autowired
	private CalculateManagerService calculateManagerService;

    @PostMapping("/calculate")
	public CalculateResponseVo calculate(@RequestBody CalculateRequestVo requestVo) {
    	CalculateResponseVo responseVo = calculateManagerService.calculate(requestVo);
    	return responseVo;
    }

    @GetMapping("/desc")
    public CalcResultDescVo getCalcResultDesc(@RequestParam("calcResultId") long calcResultId) {
    	CalcResultDescVo crdv = calculateManagerService.getCalcResultDesc(calcResultId);
    	return crdv;
    }
}
