package xbc.formula.calcmgr.service.impl;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import xbc.formula.calcmgr.logic.CalculateManagerLogic;
import xbc.formula.calcmgr.logic.QueryCalcResultLogic;
import xbc.formula.calcmgr.service.CalculateManagerService;
import xbc.formula.calcmgr.vo.CalcResultDescVo;
import xbc.formula.calcmgr.vo.CalculateRequestVo;
import xbc.formula.calcmgr.vo.CalculateResponseVo;

@Service
public class CalculateManagerServiceImpl implements CalculateManagerService {
	
	@Autowired
	private CalculateManagerLogic calculateManagerLogic;
	
	@Autowired
	private QueryCalcResultLogic queryCalcResultLogic;

	@Override
	public CalculateResponseVo calculate(CalculateRequestVo requestVo) {
    	CalculateResponseVo responseVo = calculateManagerLogic.calculate(requestVo);
    	return responseVo;
	}

	@Override
	public CalcResultDescVo getCalcResultDesc(long calcResultId) {
		CalcResultDescVo crdv = queryCalcResultLogic.getCalcResultDesc(calcResultId);
    	return crdv;
	}

}
