package xbc.formula.framework.interceptor;

import java.lang.reflect.Method;

import org.springframework.core.MethodParameter;
import org.springframework.http.MediaType;
import org.springframework.http.converter.HttpMessageConverter;
import org.springframework.http.server.ServerHttpRequest;
import org.springframework.http.server.ServerHttpResponse;
import org.springframework.web.bind.annotation.RestControllerAdvice;
import org.springframework.web.servlet.mvc.method.annotation.ResponseBodyAdvice;

import xbc.formula.framework.vo.ResponseVo;

@RestControllerAdvice
public class NormalResponseHandler implements ResponseBodyAdvice<Object> {

    @Override
    public Object beforeBodyWrite(
            Object obj, MethodParameter mp, MediaType mt, Class<? extends HttpMessageConverter<?>> clazz,
            ServerHttpRequest request, ServerHttpResponse response) {
    	ResponseVo rv = new ResponseVo();
        rv.setCode(0);
        rv.setData(obj);
        return rv;
    }

    @Override
    public boolean supports(MethodParameter mp, Class<? extends HttpMessageConverter<?>> clazz) {
        Method method = mp.getMethod();
        Class<?> dc = method.getDeclaringClass();
        TransferToResponseVoAnnotation ttrva = dc.getAnnotation(TransferToResponseVoAnnotation.class);
        if (ttrva != null && !ttrva.value()) {
            return false;
        }
        Class<?> rtnClass = method.getReturnType();
        if (!ResponseVo.class.isAssignableFrom(rtnClass)) {
            // 如果返回值不是  CdyfszResponseVo
            ttrva = method.getAnnotation(TransferToResponseVoAnnotation.class);
            if (ttrva == null || ttrva.value()) {
                return true;
            }
        }
        return false;
    }
}
